int bin_a_7 (int valor);
void print_display (int d2,int d1);
void print_led (int led);
void parpadeo_all (int d2, int d1, int valor);
void codigo (int array[],int num);
short game_pad (void);
void print_score(int score);
int control_score(int score,int act);
void juego_terminado(int estado);



unsigned int lectura=0,bin_255=0,bin_99=0;
const int parpadeo=500;


void main() 
{
  unsigned int uni=0,dec=0,temp1=0,temp2=0,temp4=0,i=0;
  unsigned int x=0,y=0,z=0, cont=0,temp3=0;
  unsigned short pad=00000000;
  unsigned int n_gen=0, nivel=0;
  unsigned int score=3, salto=0,bandera=0,play=1;
  unsigned int juego=0;//sera 1 para ejercicio 1 y 2 para ejercicio 2
     
  ANSEL  = 0x01;              // Configure AN0 pin as analog
  ANSELH = 0;                 // Configure other AN pins as digital I/O
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISA  = 0xFF;              // PORTA is input
  TRISB  = 0;
  TRISC  = 0;                 // PORTC is output
  TRISD  = 0;                 // PORTD is output
  
  PORTB=0;                    // inicializo los puertos en cero
  PORTC=0;
  PORTD=0;
  
  while(1)//lazo infinito para repetir programacion general desde el inicio
  {
    uni=0; dec=0; temp1=0; temp2=0; temp4=0; i=0;
    x=0; y=0; z=0; cont=0 ;temp3=0;
    pad=00000000;
    n_gen=0; nivel=0;
    score=12; salto=0; bandera=0; play=1;

    while(temp1==0)    //Mostrando iniciales de nombre
    {
      print_display(125,57);

      if (RA4_bit==1)
      {
         delay_ms(1);
         if (RA4_bit==0)
         {
            temp1=1;
            delay_ms(1);
            juego=1;//entrar a ejercicio 1
         }
      }
      else
      {  delay_ms(1);
         if (RA3_bit==1)
        {
           delay_ms(1);
           if (RA3_bit==0)
           {
              temp1=1;
              delay_ms(1);
              juego=2;//entrar a ejercicio 2
           }
        }
      }
    }
    
    if(juego==1)//si se presiona RA4 entrar en Ejercico 1
    {
      while (temp2==0)
      {
        lectura = ADC_Read(0);   // Conversion analogica Digital (Ejercicio #1)
        bin_255 = lectura*0.25;
        bin_99  = bin_255*0.389;
        nivel   = bin_255+1;
        uni     = bin_99%10;
        dec     = bin_99/10;
        print_display(bin_a_7(dec),bin_a_7(uni));
        print_led(bin_255);

        if (RA4_bit==1)
        {
           delay_ms(1);

           while(temp2==0)
           {
             if (RA4_bit==0)//saldra del ejercico 1 si se presiona nuevamente
             {
                delay_ms(1);
                temp2=1;
                delay_ms(1);
             }
           }
        }
        else temp2=0;
      }
      juego=0;//enceramos nuevamente la variable
    }

    if(juego==2)
    {
      for(i=0;i<3;i++) //parpadeo de transicion entre Ejercicio #1 y #2
      parpadeo_all (64, 64, 0xff);


      while (temp3==0)//BUCLE PARA CONTROLAR EL JUEGO******************************
      {
             lectura = ADC_Read(0);   // Conversion analogica Digital (Ejercicio #1)
             bin_255 = lectura*0.25;
             bin_99  = bin_255*0.389;
             nivel   = bin_255+1;
             n_gen=(rand()%10)+1; //Numero aleatorio
             cont=((257-nivel)*2)+200;

             bandera=0;

             switch (n_gen)
            {
                 case 1:
                 {
                      x=54;y=0;z=3;
                      do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 2:
                 {
                      x=48;y=48;z=5;
                     do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 3:
                 {
                      x=48;y=6;z=9;
                      do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 4:
                 {
                      x=6;y=48;z=6;
                      do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 5:
                 {
                      x=6;y=6;z=10;
                      do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 6:
                 {
                      x=0;y=54;z=12;
                      do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 7:
                 {
                      x=48;y=0;z=1;
                     do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 8:
                 {
                      x=6;y=0;z=2;
                     do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 9:
                 {
                      x=0;y=48;z=4;
                     do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 case 10:
                 {
                      x=0;y=6;z=8;
                     do
                      {
                              print_display (x,y);//presento grafico de juego
                              print_score(score);//presento puntuacion tipo barra
                              pad=game_pad (); //adquiero datos del teclado

                              if((pad==z)&&(bandera==0))//pregunta si coincide grafico y codigo ingresado
                              {
                                score++;//aumentar puntuacion
                                bandera=1;
                                break;//si coincide salir y aumentar puntuacion
                              }

                              cont--;
                              if(cont==0)//si se acaba el tiempo salir y disminuir puntuacion
                              {score--;break;}//score=control_score(score,0);

                          //parpadeo_all (73, 73, 0xff);//********************************

                      }while(1); //////////////////////////////////////////////////////////////////////////////////////////////////////
                      break;
                 }
                 default: break;
            }


             if(score<=0)//si el puntaje llega a cero entonces juego terminado
             {print_led(0);temp3=1;juego_terminado(0);}
             else
             if(score>=16)
             {print_led(0);temp3=1;juego_terminado(1);}
       }

    }
  }
}

int bin_a_7 (int valor)
{
    switch (valor)
    {
           case 0: return 63;
           case 1: return 6;
           case 2: return 91;
           case 3: return 79;
           case 4: return 102;
           case 5: return 109;
           case 6: return 125;
           case 7: return 7;
           case 8: return 127;
           case 9: return 103;
           default: break;
    }

}

void print_display (int d2,int d1)
{
    PORTC=d1;
    PORTD=d2;
}

void print_led (int led)
{
     PORTB=led;
}

void parpadeo_all (int d2, int d1, int valor)
{
     print_display (d2,d1);
     print_led (valor);
     delay_ms(parpadeo);
     print_display (0,0);
     print_led (0);
     delay_ms(parpadeo);
}

short game_pad (void)
{
    unsigned short temp=000000;
    
    temp.F3=RA4_bit;
    delay_ms(1);
    temp.F2=RA3_bit;
    delay_ms(1);
    temp.F1=RA2_bit;
    delay_ms(1);
    temp.F0=RA1_bit;
    delay_ms(1);
    return temp;

}

void print_score(int score)
{
  if(score==0)
  print_led(0);
  
  if((score>0)&&(score<=2))
  print_led(128);

  if((score>2)&&(score<=4))
  print_led(192);

  if((score>4)&&(score<=6))
  print_led(224);

  if((score>6)&&(score<=8))
  print_led(240);

  if((score>8)&&(score<=10))
  print_led(248);

  if((score>10)&&(score<=12))
  print_led(252);

  if((score>12)&&(score<=14))
  print_led(254);

  if(score==15)
  print_led(255);
}

int control_score(int score,int act) //con 1 aumentar score y con 0 disminuir
{
    delay_ms(1);
    
    if(score==0)
    {
       if(act==1)
       return score++;
       else
       {
        if(act==0)
        return score;
       }
    }

    if(score==15)
    {
        if(act==1)
        return score;
        else
        {
            if(act==0)return score--;
        }
    }

    if(act==1)
    return score++;
    else
    return score--;
}

void juego_terminado(int estado)//estado en 1 entonces termine y gane sino termine y perdi
{
     int g=0,i=0;
     if (estado==1)//si se gano el juego
     {
        for(g=0;g<3;g++)
        {
            print_display(63,63);
            delay_ms(350);
            print_display(64,64);
            delay_ms(350);
        }
     }
     
     if (estado==0)//si se gano el juego
     {
        for(g=0;g<3;g++)
        {
            print_display(84,84);
            delay_ms(350);
            print_display(8,8);
            delay_ms(350);
        }
     }
     
     for(i=0;i<3;i++)
     {
       print_display(125,63);
       delay_ms(500);
       print_display(0,0);
       delay_ms(500);
     }

     return;
}